package cn.koogame.android;


import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Handler;
import android.os.Message;
import android.text.Editable;
import android.widget.EditText;
import android.widget.Toast;
import cn.koogame.ui.KooUiActivity;

public class NumberDialog 
{	
	private String mNumber = null;
	private static final int MSG_GET_NUMBER = 8;
	private static final int MSG_DO_GET_PROP_FAIL = 9;
	private Context mContext = null;
	
	private static final String mTitle = "关注\"雷电2012\"微信公众账号可以\n获得\"金币兑奖码\"\n(微信号:koofighter)\n\n请输入\"金币兑换码\"，兑换金币！";
	private static final String mMsg = "领取失败！请检查兑换码是否有效。";
	private static final String mGetPropsFailed = "领取失败";
	private Object mLockObj = null;
	
	private String authCode[] = {"20322","13506","36605","58116","11357","29831"};
	public NumberDialog(Context context)
	{
		mContext = context;
		mLockObj = new Object();
	}
	
	private void showEditDialog()
	{
		AlertDialog.Builder dlg = new AlertDialog.Builder(mContext);
		dlg.setMessage(mTitle);
		final EditText edit = new EditText(mContext);
		dlg.setView(edit);
		
		dlg.setPositiveButton(android.R.string.ok,
				new DialogInterface.OnClickListener()
		{
			@Override
			public void onClick(DialogInterface arg0, int arg1)
			{
				Editable editText = edit.getEditableText();
				synchronized (mLockObj)
				{
					if (editText != null )
					{
						mNumber = editText.toString();
					}
					boolean isGood = false;
					if(mNumber != null)
					{
						for (int i = authCode.length-1;i>=0;i--){
							if(authCode[i].equals(mNumber)){
								isGood = true;
								break;
							}
								
						} 
					}
					SharedPreferences sharedata = mContext.getSharedPreferences("data", 0);  
					String str = sharedata.getString("authCode", null);
					
					if(str!= null && isGood){
						String[] shareAuthCodes = str.split("#");
						
						for(int i = 0;i<shareAuthCodes.length;i++){
							if(shareAuthCodes[i].equals(mNumber)){
								isGood = false;
								break;
							}
						}
					}
					if (! isGood)
					{
						mNumber = null;
						Toast.makeText(mContext, mMsg, Toast.LENGTH_LONG).show();
					}
					else{
						
						SharedPreferences.Editor editor =sharedata.edit();
						String savdata = str;
						if(savdata != null)
							savdata = savdata + "#" + mNumber;
						else
							savdata = mNumber;
						
						editor.putString("authCode", savdata);  
						editor.commit();
						
						Toast.makeText(mContext, "领取成功！金币+500", Toast.LENGTH_LONG).show();
					}
				}
				
			}
			
		});
		dlg.setNegativeButton(android.R.string.cancel, new DialogInterface.OnClickListener()
		{
			@Override
			public void onClick(DialogInterface arg0, int arg1)
			{
			}
			
		});

		dlg.show();
	
	}
	
	private static Handler mHandler = new Handler() 
	{
		public void handleMessage(Message msg) 
		{
			switch (msg.what) 
			{
			case MSG_GET_NUMBER:
			{
				NumberDialog utils = (NumberDialog)msg.obj;
				utils.showEditDialog();
				break;
			}
			case MSG_DO_GET_PROP_FAIL:
			{
				NumberDialog utils = (NumberDialog)msg.obj;
				utils.showPropsFailed();
			
				break;
			}
			}
		}
	};
	
	public void showPropsFailed()
	{
		Toast.makeText(mContext, mGetPropsFailed, Toast.LENGTH_LONG).show();
	}
	
	public void onDrawFrame()
	{
		synchronized (mLockObj)
		{
			if (mNumber != null)
			{
				KooUiActivity.NativeGetNumberCallBack("1");			
				mNumber = null;			
			}
		}
	}
	
	public static  void getNumber()
	{
		Message msg = mHandler.obtainMessage();
		msg.what = MSG_GET_NUMBER;
		KooUiActivity activity = (KooUiActivity)(KooUiActivity.sAppContext);
		msg.obj = activity.mNumberDialog;
		mHandler.sendMessage(msg);
	}
	
	public static void doGetPropFail()
	{
		Message msg = mHandler.obtainMessage();
		msg.what = MSG_DO_GET_PROP_FAIL;
		KooUiActivity activity = (KooUiActivity)(KooUiActivity.sAppContext);
		msg.obj = activity.mNumberDialog;
		mHandler.sendMessage(msg);
		
	}

}
